/* $Id: parse.c,v 1.12 2000/12/15 04:29:18 emf Exp $ */

/* parse a line from the user */
#include "config.h"

#include "icb.h"
#include "externs.h"

extern Tcl_Interp *interp;
char *nextword();

char *argv[10];

void
parse (char* line)
{
	char cmdbuf[2048];
	int result = TCL_OK;
	char* s = line;
	char* args;
	char* cmd;
	Tcl_CmdInfo cmdinfo;

	/* see if it's just message text */
	if (*s != gv.cmdchar || (*++s==gv.cmdchar)) {
		send_default(s,1);
		return;
	}

	/* check to see if it's a shell command */
	/* what a mess, but it works */
	if (*s == '!') {
		char *w;
		s++;

		if (gv.restricted) {
			sprintf(mbuf,
				"%s[=Error=] c_shell: no shell commands to restricted mode%s",
				printcolor(ColERROR, ColSANE),
				printcolor(ColSANE, ColSANE));
			putl(mbuf, PL_SCR);
			return;
		}

		if ((*s == ' ' || *s == '\t') && ((w = nextword(s)) != NULL)) {
			argv[0] = "c_shell"; argv[1] = w; argv[2] = NULL;
			c_shell(NULL, interp, 2, argv);
		} else if (*s != '\0') {
			argv[0] = "c_shell"; argv[1] = s; argv[2] = NULL;
			c_shell(NULL, interp, 2, argv);
		} else {
			argv[0] = "c_shell"; argv[1] = NULL;
			c_shell(NULL, interp, 1, argv);
		}
		return;
	}

	putl (line, PL_LOG);

	cmd = getword (s);

	if (strcmp (cmd, "tcl") == 0) {
		/* Pass it literally to tcl. */
		result = Tcl_Eval (interp, s + 4);

	} else if (Tcl_GetCommandInfo (interp, cmd, &cmdinfo)) {
		/* It's a command implemented in tcl. */
		/* XXX possible bounds-overwrite if cmdbuf is smaller than s */
		quoteify (s, cmdbuf);
		result = Tcl_Eval (interp, cmdbuf);

	} else {
		/* Just pass it directly to the server. */
		args = findspace (s);
		sendcmd (s, args);
		return;
	}

	/* Print the tcl result. */
	if (result == TCL_OK) {
		if (*interp->result != 0)
			putl(interp->result, PL_SL);
	} else {
		if (interp->result) {
			sprintf(mbuf, 
				"%s[=Error=] %s%s",
				printcolor(ColERROR, ColSANE),
				interp->result,
				printcolor(ColSANE, ColSANE));
			putl(mbuf, PL_SL);
		} else {
			sprintf(mbuf,
				"%s[=Error=] Unknown Tcl error%s",
				printcolor(ColERROR, ColSANE),
				printcolor(ColSANE, ColSANE));
			putl(mbuf, PL_SL);
		}
	}
}


/* starting at a word, find the start of the next one */
char *nextword(s)
char *s;
{
	while (*s != ' ' && *s != '\t' && *s != '\0') s++;
	while ((*s == ' ' || *s == '\t') && *s != '\0') s++;
	if (*s == '\0')
		return(0);
	else
		return(s);
}
