/* $Id: readlineinit.c,v 1.16 2000/12/12 07:02:07 hoche Exp $ */
#include "config.h"

#ifdef HAVE_STDIO_H
#include <stdio.h>
#endif
#ifdef HAVE_UNISTD_H
#include <unistd.h>
#endif

#include <readline/readline.h>

#include "icb.h"
#include "externs.h"


/*
 * readlineinit - set up for readline()
 */

void
readlineinit(void)
{
	char *editor;
	int handletab();

	rl_initialize ();

	/*
	 * bind the tab key
	 */
	rl_bind_key_in_map('\t', handletab, vi_insertion_keymap);
	rl_bind_key_in_map('\t', handletab, vi_movement_keymap);
	rl_bind_key_in_map('\t', handletab, emacs_standard_keymap);

	rl_getc_function = getc_or_dispatch;

#ifdef HAVE_READLINE_2
	rl_vi_editing_mode(); /* default to vi, dammit. */
#else
	rl_vi_editing_mode(0,0); /* default to vi, dammit. */
#endif
	gv.editmode = "vi";

	editor = (char *)getenv("EDITOR");
	if (!editor)
		editor = (char *)getenv("VISUAL");

	if (editor != NULL)
		if (strcmp(basename(editor),"emacs")==0)
		{
#ifdef HAVE_READLINE_2
			rl_emacs_editing_mode();
#else
			rl_emacs_editing_mode(0,0);
#endif
			gv.editmode = "emacs";
		}
}
