/* $Id: contoport.c,v 1.5 2000/10/02 11:25:58 hoche Exp $ */

/* connect to a port */
#include "config.h"

#ifdef HAVE_STDIO_H
#include <stdio.h>
#endif
#ifdef HAVE_SYS_TYPES_H
#include <sys/types.h>
#endif
#ifdef HAVE_FCNTL_H
#include <fcntl.h>
#endif
#ifdef HAVE_SYS_SOCKET_H
#include <sys/socket.h>
#endif
#ifdef HAVE_NETINET_IN_H
#include <netinet/in.h>
#endif
#ifdef HAVE_NETDB_H
#include <netdb.h>
#endif
#ifdef HAVE_STRING_H
#include <string.h>
#endif

#include "ipcf.h"
#include "externs.h"

struct in_addr *_getaddress();

int
connecttoport(host_name, port_number)
char *host_name;
int port_number;
{
	int s;
	struct sockaddr_in saddr;
	struct in_addr *addr;

	fprintf(stderr,"Trying to connect to port %d of host %s.\n", port_number, host_name);

	/* get the client host inet address */
	if ((addr = _getaddress(host_name)) == 0) {
		fail = "can't lookup server INET address";
		return(-1);
	}

	/* insert hostname into address */
	memset (&saddr, 0, sizeof (saddr));
	memcpy (&saddr.sin_addr, addr, 4);

	/* fill in socket domain and port number */
	saddr.sin_family = AF_INET;
	saddr.sin_port = htons((u_short)port_number);

	/* create a socket */
	if ((s = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
		fail = "couldn't create socket";
		fprintf(stderr,"icb: couldn't connect to %s server.\n",host_name);
		return(-1);
	}

	/* connect it to the server inet address */
	if (connect(s, (struct sockaddr *) &saddr, sizeof(saddr)) < 0) {
		fail = "couldn't connect to server (not running?)";
		fprintf(stderr,"icb: couldn't connect to %s server.\n",host_name);
		return(-1);
	}

	/* make it non-blocking */
#ifndef FNDELAY
#define FNDELAY 0
#endif
#ifndef O_NDELAY
#define O_NDELAY 0
#endif
#ifndef O_NONBLOCK
#define O_NONBLOCK 0
#endif
#ifdef hpux
#define FNDELAY 0
#define O_NDELAY 0
#endif
	if (fcntl(s, F_SETFL, FNDELAY | O_NDELAY | O_NONBLOCK) < 0) {
		fail = "contoport: fcntl";
		return(-1);
	}

	port_fd = s;
	return(0);
}
