/* $Id: getaddr.c,v 1.5 2000/10/02 11:25:59 hoche Exp $ */

/*

Given a string, return an internet address.

This accepts address in the form of 

num.num.num.num
[num.etc]
machine.dom.dom.dom

*/
#include "config.h"

#ifdef HAVE_STDIO_H
#include <stdio.h>
#endif
#ifdef HAVE_SYS_TYPES_H
#include <sys/types.h>
#endif
#ifdef HAVE_SYS_SOCKET_H
#include <sys/socket.h>
#endif
#ifdef HAVE_NETINET_IN_H
#include <netinet/in.h>
#endif
#ifdef HAVE_ARPA_INET_H
#include <arpa/inet.h>
#endif
#ifdef HAVE_NETDB_H
#include <netdb.h>
#endif
#ifdef HAVE_STRING_H
#include <string.h>
#endif

struct in_addr *
_getaddress(spoo)
char *spoo;
{
	static struct in_addr iaddr;
	struct hostent *hp;

	/* handle case of "[num.num.num.num]" */
	if (*spoo == '[') {
		char *p;

		spoo++;
		for (p = spoo; *p != '\0'; p++)
			if (*p == ']') {
				*p = '\0';
				break;
			}
	}

	/* handle case of "num.num.num.num" */
	if (*spoo >= '0' && *spoo <= '9') {
		if ((iaddr.s_addr = (unsigned long)inet_addr(spoo)) == -1)   
			return(0);  
		return(&iaddr);
	} 

	/* handle a symbolic address */
	if ((hp = gethostbyname(spoo)) == (struct hostent *) 0) 
		return(0); 

	/* copy address into inet address struct */
	memcpy (&iaddr.s_addr, hp->h_addr, hp->h_length);

	return((struct in_addr *) &iaddr);
}
