/* $Id: readpacket.c,v 1.5 2000/10/02 11:26:00 hoche Exp $ */

/* read a packet of data into an Ibuf */

/* return -2 if read failed because user disconnected */
/* return -1 if read failed because of some error */
/* return  0 if packet is still incomplete */
/* return  1 if packet is complete */

#include "config.h"

#ifdef HAVE_UNISTD_H
#include <unistd.h>
#endif
#ifdef HAVE_STDIO_H
#include <stdio.h>
#endif
#ifdef HAVE_SYS_TYPES_H
#include <sys/types.h>
#endif
#ifdef HAVE_ERRNO_H
#include <errno.h>
#endif

#include "ipcf.h"
#include "cbuf.h"
#include "externs.h"

extern int errno;

int
_readpacket(user, p)
int user;
struct Cbuf *p;
{
	register int ret;

	if (p->new) {
		/* starting a new command */
		p->rptr = p->buf;
		/* read the length of the command packet */
		if ((ret = read(user, p->rptr, 1)) < 0)
		{
			if ((errno == EWOULDBLOCK) || (errno == EAGAIN)) {
				return(0);
			}else {
				fail = "_readpacket:read packet length";
				return(-1);
			}
		}
		if (!ret)
			return(-2);
		p->size = p->remain = *(p->rptr);
		p->rptr++;
		p->new = 0;
	}

	/* read as much of the command as we can get */
	if ((ret = read(user, p->rptr, p->remain)) < 0)
	{
		if ((errno == EWOULDBLOCK) || (errno == EAGAIN)) {
			return(0);
		} else {
			fail = "_readpacket:read incomplete data";
			return(-1);
		}
	}
	if (!ret)
		return(-2);

	/* advance read pointer */
	p->rptr += ret;

	/* see if we read the whole thing */
	if ((p->remain -= ret) == 0) {
		/* yes */
		*p->rptr = '\0';
		p->new = 1;
		return(1);
	} else {
		/* command still incomplete */
		return(0);
	}
}
