/* $Id: sendpacket.c,v 1.5 2000/10/02 11:26:01 hoche Exp $ */

/* send a packet along a socket file descriptor */

#include "config.h"

#ifdef HAVE_STDIO_H
#include <stdio.h>
#endif
#ifdef HAVE_SYS_TYPES_H
#include <sys/types.h>
#endif
#ifdef HAVE_SYS_SOCKET_H
#include <sys/socket.h>
#endif
#ifdef HAVE_ERRNO_H
#include <errno.h>
#endif
#ifdef HAVE_STRING_H
#include <string.h>
#endif


extern int errno;

int
_sendpacket(s, pkt)
int s;
char *pkt;
{
	int ret;
	int totlength;

	/* set up a sample packet for testing purposes */
	totlength = (unsigned char)*pkt + 1;

	if ((ret = send(s, pkt, totlength, 0)) < 0) {
		if ((errno == EWOULDBLOCK) || (errno == EAGAIN))
			return(0);
		else if (errno == EPIPE)
			return(-2);
		else {
			/* DEBUG temorary fix */
			return(-2);
#ifdef NEVERDEFFED
			perror("DEBUG: _sendpacket: error in send");
			kill(getpid(), 3); /* BOOM! debug */
			sleep(20000);
			return(-1);
#endif
		}
	}
	if (ret != totlength)
		return(-1);
	return(1);
}
